package com.aghajari.axrlottiemoji;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.view.View;

import com.aghajari.emojiview.emoji.Emoji;
import com.aghajari.rlottie.AXrLottieDrawable;

public class AXrLottieEmoji extends Emoji {

    private final String fileName;

    public AXrLottieEmoji(String code, String lottieFileName) {
        super(code, 0);
        this.fileName = lottieFileName;
    }

    public String getFileName() {
        return fileName;
    }

    @Override
    public Drawable getDrawable(View view) {
        return getDrawable(view.getContext());
    }

    @Override
    public Drawable getDrawable(Context context) {
        return getDrawable(context, (int) (context.getResources().getDisplayMetrics().density * 20));
    }

    public Drawable getDrawable(Context context, int size) {
        return AXrLottieDrawable.fromAssets(context, getFileName())
                .setSize(size, size)
                .setAutoStart(true)
                .setAutoRepeat(true)
                .build();
    }
}
