package com.aghajari.axrlottiemoji;

import android.text.TextUtils;

import com.aghajari.emojiview.utils.EmojiRange;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class AXrLottieEmojiManager {

    private static Pattern pattern;
    private static Map<String, AXrLottieEmoji> map;

    public static void install(List<AXrLottieEmoji> emojis) {
        map = new HashMap<>();

        StringBuilder patternBuilder = new StringBuilder(emojis.size() * 2);
        for (AXrLottieEmoji emoji : emojis) {
            patternBuilder.append(Pattern.quote(emoji.getUnicode())).append('|');
            map.put(emoji.getUnicode(), emoji);
        }

        pattern = Pattern.compile(patternBuilder
                .deleteCharAt(patternBuilder.length() - 1).toString());
    }

    public static List<EmojiRange> findAllLottieEmojis(final CharSequence text) {
        final List<EmojiRange> result = new ArrayList<>();

        if (!TextUtils.isEmpty(text)) {
            final Matcher matcher = pattern.matcher(text);

            while (matcher.find()) {
                final AXrLottieEmoji found = map.get(text.subSequence(matcher.start(), matcher.end()).toString());

                if (found != null) {
                    result.add(new EmojiRange(matcher.start(), matcher.end(), found));
                }
            }
        }

        return result;
    }
}
